/*
 * Scratchpad MMU - Test program
 * Copyright (C) Jack Whitham 2010
 * http://www.jwhitham.org.uk/c/smmu.html
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation
 * (version 2.1 of the License only).
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
#ifndef SIMIF_H
#define SIMIF_H

#define MM_SIZE         0x1000
#define NUM_WORDS       MM_SIZE


typedef unsigned static_cache_ref ;
typedef unsigned address_t ;
typedef unsigned data_t ;

void Simulator_Init(void);
unsigned TEST_SW_LOAD(unsigned address);
unsigned TEST_HW_LOAD(unsigned address);
void TEST_SW_STORE(unsigned address, unsigned data);
void TEST_HW_STORE(unsigned address, unsigned data);
unsigned TEST_SW_OPEN(unsigned address, unsigned size, unsigned copy_loc);
unsigned TEST_HW_OPEN(unsigned address, unsigned size, unsigned copy_loc);
unsigned TEST_SW_OPEN_RO(unsigned address, unsigned size, unsigned copy_loc);
unsigned TEST_HW_OPEN_RO(unsigned address, unsigned size, unsigned copy_loc);
void TEST_SW_CLOSE(unsigned ref);
void TEST_HW_CLOSE(unsigned ref);
unsigned TEST_SW_Get_Result_Timer(void);
unsigned TEST_HW_Get_Result_Timer(void);
void TEST_SW_Dump(void);

#endif

